// Выведение данных дальномера на дисплей

#include <LiquidCrystal_I2C.h> // библиотека дисплея  
#define echoPin 2 // определение пина для Echo  
#define trigPin 3 // определение пина для Trig  
LiquidCrystal_I2C lcd(0x3f, 16, 2);  // определение адреса и типа дисплея  
  
void setup() {  
  Serial.begin (9600);   
  pinMode(trigPin, OUTPUT);   
  pinMode(echoPin, INPUT);  
  lcd.begin(); // включение дисплея  
  lcd.backlight(); // включение подсветки  
  lcd.setCursor(0, 0); // установка курсора в начале первой строки  
  lcd.print("Hello, world!"); // фраза в первой строке  
  delay(1000); // задержка 1 секунда  
  lcd.setCursor(0, 1); // курсор в начале второй строки  
  lcd.print("I'm Ultrasonic"); // фразы во второй строке  
  delay(1000); // задержка 1 секунда  
  lcd.clear(); // очистка дисплея  
  delay(2000); // задержка 2 секунды  
  lcd.print("Distance:"); // выведение надписи на дисплей  
     
}  
  
void loop() {  
    long duration, distance;   
    digitalWrite(trigPin, LOW); // подача низкого сигнала на пин trigPin  
    delayMicroseconds(2); // задержка 2 микросекунды  
    digitalWrite(trigPin, HIGH); // подача высокого сигнала на пин trigPin  
    delayMicroseconds(10); // задержка 10 микросекунд  
    digitalWrite(trigPin, LOW); // подача низкого сигнала на пин trigPin  
    duration = pulseIn(echoPin, HIGH);   
    distance = duration / 58;  
      
    Serial.print(distance); // данные в монитор порта  
    Serial.println(" cm"); // вывод надписи "cm" после      значения дистанции в мониторе порта  
    lcd.setCursor(10,0);  // курсор на 10 знак первой строки
    lcd.print(distance); // вывод данных на дисплей   
    lcd.print(" cm"); // вывод надписи "cm" после значения  дистанции  
    lcd.print("    "); // пробелы - удаление лишних символов при увеличении разрядности значений  
    delay(500); // задержка 0.5 секунды между измерениями  
}  
